<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Entity\EmailTemplateEntity;
use RxConnexionBundle\Entity\PatientEmailEntity;
use RxConnexionBundle\Form\EmailTemplateForm;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\DeviceEntity;

use RxConnexionBundle\Form\DeviceForm;

/**
 * @Route("/main/email_template")
 */
class EmailTemplateController extends Controller
{
    /**
     * @Route("", name="email_template")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Email Template'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/EmailTemplate/index.html.twig', array(
            'title' => 'Manage Email Template',
            'page_title' => 'Manage Email Template',
            'javascripts' => array('rxconnexion/admin/js/emailTemplate/emailTemplate.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="email_template_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Email Template Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:EmailTemplateEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('email_template_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['description'],
//                    $row['emailType_description'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "email_template_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Email Template New', 'Admin Email Template Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $emailTemplate = $em->getRepository('RxConnexionBundle:EmailTemplateEntity')->find(base64_decode($id));
        if(!$emailTemplate) {
            $emailTemplate = new EmailTemplateEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(EmailTemplateForm::class, $emailTemplate, $formOptions);

        if($request->getMethod() === 'POST') {

            $emailTemplate_form = $request->get($form->getName());
            $result = $this->processForm($emailTemplate_form, $emailTemplate, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('email_template'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('email_template_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('email_template_form'), 302);
                }
            } else {
                $form->submit($emailTemplate_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Email Template';

        return $this->render('@RxConnexion/EmailTemplate/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/emailTemplate/emailTemplate_form.js?v=1.0.1'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($email_template_form, $email_template, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:EmailTemplateEntity')->validate($email_template_form);

        if(!count($errors)) {

            switch($email_template_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($email_template);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Email Template',
                            $em->getClassMetadata(EmailTemplateEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $email_template;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Email Template',
                        $em->getClassMetadata(EmailTemplateEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $email_template;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Email Template',
                        $em->getClassMetadata(EmailTemplateEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $email_template;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($device);
                        $email_template->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route(
     *      "/email_template_data/{email_type}",
     *      defaults = {
     *          "email_type": null,
     *      },
     *      name = "email_template_data"
     * )
     */
    public function emailTemplateData(Request $request, $email_type) {

        $em = $this->getDoctrine()->getManager();
        $emailTemplateData = $em->getRepository('RxConnexionBundle:EmailTemplateEntity')->findOneBy(array(
            'emailType' => urldecode($email_type),
            'isDeleted' => 0
        ));
        $emailTemplateDataArray = array();
        if ($emailTemplateData && $emailTemplateData != null) {
            $emailTemplateDataArray = array(
                'fax_cover_body' => $emailTemplateData->getFaxCoverBody(),
                'body' => $emailTemplateData->getBody()
            );
        } else {
            $emailTemplateDataArray = array(
                'fax_cover_body' => '',
                'body' => ''
            );
        }


        return new JsonResponse($emailTemplateDataArray);
    }

    /**
     * @Route("/autocomplete", name="email_template_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'descriptions',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:EmailTemplateEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}
